/**<pre>
 * Title: GPS Simulator
 * Copyright: Copyright (c) 2002
 * Company:   University of Oregon Computer Science Dept.
 *
 * @author Jason Prideaux
 * @version 1.0
 * </pre>
 */

package transport;

import transport.protocol.*;

import java.io.*;
import java.net.*;
import java.util.*;




/* ====================================================================== */
/** This class
 *
 */
public class SocketSender extends Thread {


	private Message message;

	private String host = "localhost";



    /* ===================================================================== */
    /** This constructor initializes the user.
     *
     *  @param  p   The port the ipaq gps receiver is listening on.
     *
     */
	public SocketSender(Message message){

		this.message = message;

	}



    /* ===================================================================== */
    /** This constructor initializes the user.
     *
     *  @param  p   The port the ipaq gps receiver is listening on.
     *
     */
	public SocketSender(Message message, String host){

		this.message = message;
		this.host = host;

	}


    /* ===================================================================== */
    /** This method
     *
     */
	public void run(){

		try{
			Socket s = new Socket( host, message.getTo() );

			//System.out.println ("Client:  sending message to port "+message.getTo() );
			BufferedOutputStream bufout = new BufferedOutputStream(s.getOutputStream());
			ObjectOutputStream 	objout = new ObjectOutputStream(bufout);

			objout.writeObject(message);
			objout.flush();
		}catch(Exception e){
			//System.out.println("Not connected to the agent. "+message.getTo());
			//e.printStackTrace();
		}

	} //method:




} //class: