/**<pre>
 * Title: iSIM
 * Copyright: Copyright (c) 2002
 * Company:   University of Oregon Computer Science Dept.
 *
 * @author Jason Prideaux
 * @version 1.0
 * </pre>
 */

package transport.protocol;

import java.io.*;
import java.awt.*;


/* ====================================================================== */
/** This class represents a Multicast message.  This message is sent by
 *  agents to the simulator, the simulator then sends the message to all
 *  agents that are with within range and certain number of hops.
 *
 */
public class BioMessage extends Sim2PMessage implements Serializable{


  	/** The health of this agent. */
  	private int health;

  	/** The oxygen of this agent. */
  	private int oxygen;

	/** The oxygen of this agent. */
  	private int weight;


    /* ===================================================================== */
    /** This constructor initializes the Message.  Object content must be added
     *  seperately with setContent() method, and the object must be
     *  Serializable.
     *
     *  @param  message   The String message.
     *  @param  from   The port the message sender listens to.
     *
     */
  	public BioMessage(int to, int from, int health, int oxygen, int weight){
		super(to, from);

		this.health = health;
		this.oxygen = oxygen;
		this.weight = weight;

	} //Constructor




    /* ===================================================================== */
    /** This method returns the name of this agent.
     *
     *  @return  String  The name of this agent.
     *
     */
	public int getHealth(){

		return health;

	} //method: getName




    /* ===================================================================== */
    /** This method returns the name of this agent.
     *
     *  @return  String  The name of this agent.
     *
     */
	public int getOxygen(){

		return oxygen;

	} //method: getName




    /* ===================================================================== */
    /** This method returns the name of this agent.
     *
     *  @return  String  The name of this agent.
     *
     */
	public int getWeight(){

		return weight;

	} //method: getName



} //class: MulticastMessage

